<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>EquationCalculator.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Calculator</a> &gt; <a href="index.source.html" class="el_package">service</a> &gt; <span class="el_source">EquationCalculator.java</span></div><h1>EquationCalculator.java</h1><pre class="source lang-java linenums">package service;

import java.util.List;
import java.util.Stack;


/**
 * this singleton class takes as a parameter an equation as a string and returns the result of that equation
 */
public class EquationCalculator {
    /**
     *  the only instance of this class - lazy initialization
     */
<span class="fc" id="L14">    private static EquationCalculator equationParser = null;</span>
    /**
     *  private constructor
     */
    private EquationCalculator() {}
    /**
     * @return the only instance of this class and if not initiated do that as well
     */
    public static EquationCalculator getInstance() {
<span class="pc bpc" id="L23" title="1 of 2 branches missed.">        if (equationParser==null) {</span>
<span class="fc" id="L24">            equationParser = new EquationCalculator();</span>
        }
<span class="fc" id="L26">        return equationParser;</span>
    }

    /**
     * @param equation an equation as a string which can deal with +,-,/,*, min(term1, term2),
     *                 max(term1, term2), sqrt(x)
     * @return the result of the given equation as a double
     * @throws Exception if the equation is not written correctly, division by zero or an operator is invalid
     */
    public double calculate(String equation) throws Exception {
<span class="fc" id="L36">        List&lt;String&gt; parsed = EquationParser.parseEquation(equation);</span>
<span class="fc" id="L37">        Stack&lt;String&gt; stack = new Stack&lt;&gt;();</span>
<span class="fc bfc" id="L38" title="All 2 branches covered.">        for (String s : parsed) {</span>
            String tempRes;
<span class="fc bfc" id="L40" title="All 2 branches covered.">            if (s.matches(&quot;^[-+/*]$&quot;)) {</span>
<span class="fc" id="L41">                String second = stack.pop();</span>
<span class="fc" id="L42">                String first = stack.pop();</span>
<span class="fc" id="L43">                tempRes = ExpressionCalculator.calculateExpression(s, first, second);</span>
<span class="fc" id="L44">            }</span>
            else {
<span class="fc" id="L46">                tempRes = ExpressionCalculator.parseOperand(s);</span>
            }
<span class="fc" id="L48">            stack.push(tempRes);</span>
<span class="fc" id="L49">        }</span>
<span class="fc" id="L50">        return Double.parseDouble(stack.pop());</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.8.202204050719</span></div></body></html>